#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define INCL_WIN
#define INCL_PM
#define INCL_DOSMEMMGR
#define INCL_DOSFILEMGR
#define INCL_DOSMISC
#include <os2.h>

CHAR    szNewDesk[64];
CHAR    szNewSysIni[]="C:\\OS2\\OS2SYS.INI";

char gBootDrive(void);

int main(int nArg, char *cArg[])
{
 PPRFPROFILE  pprfProfile;
 HAB          hab;
 BOOL         fSuccess;
 APIRET       rc;
 PSZ          Ptr;
 BOOL         bGo = TRUE;
 BOOL         bSwitch = TRUE;
 char         chResp = 'n';

 if (nArg < 2)
 {
   printf("new ini file not specified\n");
   return 1;
 }

 szNewSysIni[0] = gBootDrive();         /* get the system INI */

 strcpy(szNewDesk, cArg[1]);            /* get the USER INI   */

 hab = WinQueryAnchorBlock(HWND_DESKTOP);

 rc = DosAllocMem(&Ptr, 4096, PAG_COMMIT | PAG_READ | PAG_WRITE);
 pprfProfile = (PPRFPROFILE)Ptr;

 memset(Ptr, 0, 4096);
 pprfProfile->pszUserName = (PSZ) &pprfProfile[2];
 strcpy(pprfProfile->pszUserName, szNewDesk);
 pprfProfile->pszSysName = (PSZ) &pprfProfile[8];
 strcpy(pprfProfile->pszSysName, szNewSysIni);
 pprfProfile->cchUserName = strlen(pprfProfile->pszUserName);
 pprfProfile->cchSysName  = strlen(pprfProfile->pszSysName);

 printf("about to change:\n  user ini to %s\n  sys  ini to %s\n",
         pprfProfile->pszUserName,
         pprfProfile->pszSysName);
 printf("\ncontinue?\n");
 scanf("%c", &chResp);
 bGo = (chResp == 'y');

 if (bGo)
   fSuccess = PrfReset(hab, pprfProfile);

 return 0;
}

char gBootDrive()
{
   char  drvs[]="ABCDEFGHIJKLMNOPQRSTUVWXYZ";
   int   drvi;
   ULONG    DataBuf[10];
   APIRET   rc;

   rc = DosQuerySysInfo(5L, 5L, DataBuf, 10L);

   if (rc == 0)
     { drvi = DataBuf[0]-1;
       return(drvs[drvi]);
     }
   return(' ');
}
